//
//  JayModel.java
//  JayOpenGL
//
//  Created by Oleg Kobchenko on 04/21/06.
//  Copyright 2006,2008 Oleg Kobchenko. All rights reserved.
//

package olegyk.jawtopengl.demo;

import olegyk.jawtopengl.*;
import jay.*;
import java.io.File;

public class JayModel extends OpenGLCanvas {
	JayJNI J = null;
	boolean valid = false;
	static final String demoPath = "~system/examples/graphics/opengl/demo/";
	
	public JayModel() {
		try {
			J = new JayJNI(); 
			J.Do("BINPATH_z_=: '"+System.getProperty("jay.bin")+"'");
			J.Do("ARGV_z_=: 'j.jar';'-jijx'");
			J.Do("(3 : '0!:0 y')<BINPATH,'"+File.separator+"profile.ijs'");
			J.Do("IFJAVA_z_=: 1");
			J.Do("GLDEMOPATH=: jpath '"+demoPath+"'");
			J.Do("echo_z_=: [: 1!:2&4 ,&(10{a.)");
			J.Do("echo 'boot error:'");
			J.Do("echo 13!:12''");
			J.Do("echo 'BINPATH: ',BINPATH");
			J.Do("echo 'demo path: ',GLDEMOPATH");

			J.Do("require 'opengl'");
			J.Do("coinsert'jzopenglutil'");

			J.Do("alloc_jzopengl_=: 3 : 'wh=:y [ free i.0 [ hgl=: *+/wh'");
			J.Do("free_jzopengl_=: create_jzopengl_");
			J.Do("show_jzopengl_=: current_jzopengl_=: ]");
			J.Do("glaUseFontOutlines_jzopengl_=: glaUseFontBitmaps_jzopengl_ =: ]");
			J.Do("glqhandles_jgl2_=: ]");
			J.Do("glqwh_jgl2_=: 400 300\"_");
			J.Do("0!:0 <jpath GLDEMOPATH,'basic1.ijs'");
			valid = true;
		} catch(Exception e) {
			try { J.Do("echo 13!:12''"); } catch(Exception e1) {}
			e.printStackTrace();
		}
	}

	public void init() {
		try { 
			J.Do("ogl=: '' conew 'jzopengl'");
		} catch(Exception e) { e.printStackTrace(); }
	}
	public void reshape(int width, int height) {
		try { 
			J.Do("glqwh_jgl2_=: "+width+" "+height+"\"_"); 
		} catch(Exception e) { e.printStackTrace(); }
	}
	public void paint() {
		if (!valid) return;
		try {
			J.Do("paint''"); 
			J.Do("0 gsrotate 1"); 
		} catch(Exception e) {
			try { J.Do("echo 13!:12''"); } catch(Exception e1) {}
			e.printStackTrace(); 
			valid = false;
		}
	}
	
	public void select(String script) {
		try { 
			J.Do("gsetdefaults ''");
			J.Do("0!:0 <GLDEMOPATH,'"+script+".ijs'");
			J.Do("wh__ogl=: 0 0");
			reset(false);
			repaint();
		} catch(Exception e) { e.printStackTrace(); }
	}
	
	public String[][] menu() {
		return new String[][] {
			{"Basic",	
				"Simple", "basic1", 
				"Lighting", "basic2", 
				"Two Objects", "basic3",
				"Viewing", "basic4",
				"Cylinders", "basic5",
				null, null,
				"Colors", "colored",
				"Model", "model",
				"Teapot", "teapot",
				"Triangles", "triangle",
				null, null,
				"Texture", "textb1",
				
			},
			{"Knots",	
				"Braid", "braid", 
				"Lissajous", "lissajou",
				"Trefoil", "trefoil",
				"Torus", "torus",
			},
			{"Models",	
				"Bucky Ball", "bucky", 
				"Soccer Ball", "soccer",
			},
			{"Surface",	
				"Dini", "dini", 
				"Enneper", "ennepers",
				"Kuen", "kuen",
				"Moebius", "moebius",
				"Super Ellipse", "sellipse",
				"Umbilic Torus", "umbtorus",
				"Whitney", "whitney",
				null, null,
				"Helix", "helix",
				"Intersection", "intsect1",
				"Seashell", "seashell",
				null, null,
				"Boys", "boys",
				"Crosscap", "crosscap",
				"Klein", "klein",
				"Roman", "roman",
				null, null,
				"Cups", "cups",
				"Drums", "drum",
			},
		};
	}
}
