#!/bin/sh

JDK=/usr/java/j2sdk1.4.2_17
JAYBIN=$HOME/j602/bin
BLD=build
export PATH=$PATH:$JDK/bin

mkdir $BLD

javac -d $BLD OpenGLCanvas/*.java JayJNI/*.java
javac -d $BLD -classpath $BLD *.java
javah -d $BLD -classpath $BLD olegyk.jawtopengl.OpenGLCanvas jay.JayJNI
jar cfm $BLD/JayOpenGL.jar MANIFEST.MF -C $BLD olegyk -C $BLD jay
rm -d -f -r $BLD/olegyk $BLD/jay

INC="-I${JDK}/include -I${JDK}/include/linux -I/usr/X11R6/include -I${BLD}"
LIB="-L$BLD -L/usr/lib -L/usr/X11R6/lib -L$JDK/jre/lib/i386 -L$JAYBIN"
LINK="-lm -lGL -lGLU -lpthread -lX11 -lXext -ljawt -lj"
OPT=-shared

gcc $OPT $INC $LIB $LINK OpenGLCanvas/OpenGLCanvas.c -o $BLD/libOpenGLCanvas.so

gcc $OPT $INC $LIB $LINK JayJNI/JayJNI.c -o $BLD/libJayJNI.so

rm $BLD/*.h
